<?php 
//ini_set('display_errors',1);
session_start();
require_once ("../../config/Cado.php");
require_once ("../distribucion/cDistribucion.php");
$oDistribucion = new cDistribucion();
require_once("../traspaso/cTraspaso.php");
$oTraspaso = new cTraspaso();
require_once("../kardex/cKardex.php");
$oKardex = new cKardex();
require_once ("../documento/cDocumento.php");
$oDocumento= new cDocumento();
require_once ("../talonario/cTalonario.php");
$oTalonario= new cTalonario();
require_once("../formatos/formato.php");


require_once ("../stock/cStock.php");
$oStock = new cStock();



if($_POST["action"]=="agregarcantidad"){ 


if($_POST['can']>0){

$dts3 = $oDistribucion->mostrarSumaAlmacenes($_POST['cat_id'],$_POST['lab_id'],$_POST['almdes_id']);
$dt3 = mysqli_fetch_array($dts3);
$cantidad_agregada = $dt3['sumatotal']*1;


$stock_origen = mysqli_fetch_array($oStock->stock_por_presentacion($_POST['cat_id'],$_POST['lab_id'],$_POST['almori_id']))['tb_stock_num']*1;

$totalcantidadusada  = $cantidad_agregada + $_POST['can'];

$stockrestante = $stock_origen-$totalcantidadusada;

/* echo $cantidad_agregada.'.....'.'</br>';
echo $stock_origen.'.....'.'</br>';
echo $stockrestante.'.....'.'</br>'; */



if($stockrestante>=0){

$dts2 = $oDistribucion->mostrarporAlmacenes($_POST['almori_id'],$_POST['almdes_id'],$_POST['cat_id'],$_POST['lab_id']);
$numrows = mysqli_num_rows($dts2);

if($numrows>0){
	// modifica
	$dt2 = mysqli_fetch_array($dts2);
	$id_registro = $dt2['tb_distribucioncarrito_id'];
	//echo $id_registro;
	
	
	$oDistribucion->modificar_campo_carrito($id_registro,'can',$_POST['can']);
	
	
}else{
	// registra
	$oDistribucion->insertarcarrito($_POST['cat_id'],$_POST['lab_id'],$_POST['can'], $_POST['almori_id'],$_POST['almdes_id'],$_SESSION['usuario_id']);
}


 $data["est"]=1;
$data["msj"]="Agregado correctamente.";
}else{
	$data["msj"]="Stock superado.";
	$data["est"]=0;
}

}else{
	
	$oDistribucion->eliminar($_POST['cat_id'],$_POST['lab_id'],$_POST['almori_id'],$_POST['almdes_id']);
	$data["est"]=1;
$data["msj"]="Item eliminado.";
}

echo json_encode($data);


}



if($_POST["action"]=="seleccionaralmacen"){ 


$alm_id = $_POST['alm_id'];

if($_POST['check']=="0"){

unset($_SESSION["alm_id"][$alm_id]);	

}else if($_POST['check']=="1"){
	
$_SESSION["alm_id"][$alm_id] = $alm_id;

}




if(isset($_SESSION['alm_id'])){
	$num_rows=count($_SESSION['alm_id']);
}else{
	$num_rows="0";
}




$data["can"] = $num_rows;

echo json_encode($data); 

}



if($_POST["action"]=="insertar"){
	
	$reg = false;
		
	$dts7 = $oDistribucion->mostrarSumaProductosSeleccionados();		
	while($dt7 = mysqli_fetch_array($dts7)){
		$cantidadagregada = $dt7['cantidad'];
		
		//$stock = mysqli_fetch_array($oStock->stock_por_presentacion($dt7['tb_catalogo_id'],$dt7['tb_laboratorio_id'],$_POST['almori_id']))['tb_stock_num']*1; 
		
		$dts=$oStock->stock_por_presentacion($dt7['tb_catalogo_id'],$dt7['tb_laboratorio_id'],$_POST['almori_id']);
		$dt = mysqli_fetch_array($dts);
			$sto_id		=$dt['tb_stock_id'];
			$sto_num	=$dt['tb_stock_num'];
			$pro_nom	=$dt['tb_producto_nom'];
		mysqli_free_result($dts);
		
		
		if($sto_num>=$cantidadagregada){
			
		}else{
			$reg = true;
			$msj.="<strong style='background-color:#DC4C64;color:#fff;' >- ".$pro_nom.'</strong> <br/>';
		}
	}
	
	if($reg==false){
	
	foreach($_SESSION["alm_id"] as $indice=>$almdes_id){
		 
		// echo '...'.$almdes_id;
		 
		/// registros del traspaso
	
		
		$dts= $oDocumento->mostrarUno(28);
		$dt = mysqli_fetch_array($dts);
		$doc_nom=$dt['tb_documento_nom'];
		$doc_abr=$dt['tb_documento_abr'];
		mysqli_free_result($dts);
		
		if($doc_abr=='TR'){
		$ser = 'TR'.$_SESSION['usuario_ser'];
		}
		
		$dts= $oTalonario->correlativo($_SESSION['puntoventa_id'],28,$ser);
		$dt = mysqli_fetch_array($dts);
			$tal_id=$dt['tb_talonario_id'];
			$tal_ser=$dt['tb_talonario_ser'];
			$tal_fin=$dt['tb_talonario_fin'];
			$tal_num=$dt['tb_talonario_num'];
		mysqli_free_result($dts);
		$numero=$tal_num;
		$largo=strlen($tal_fin);
		$numero=str_pad($numero,$largo, "0", STR_PAD_LEFT);
		$numdoc=$tal_ser.'-'.$numero;
		$now =  date('d-m-Y h:i:s a');
		$fec = date("d-m-Y");
		$oTraspaso->insertar(
		fecha_mysql($fec),
		$numdoc,
		'DISTRIBUCION - '.$now,
		$_POST['almori_id'],
		$almdes_id,
		$_SESSION['usuario_id'],
		1
	);
		
		$dts=$oTraspaso->ultimoInsert();
		$dt = mysqli_fetch_array($dts);
		$tra_id=$dt['id'];
		mysqli_free_result($dts);
	
		$estado='1';
		if($tal_num==$tal_fin)
		{
			$estado='2';
		}
		$numero=$tal_num+1;
		$rs3 = $oTalonario->actualizar_correlativo($tal_id, $numero, $estado);
		

		$kar_des='TRASPASO';
		$mod_id = 5; 
		$idm=$tra_id;
		$oKardex->insertar(			
			fecha_mysql($fec),			
			$kar_des,
			$mod_id,
			$idm,
			$_SESSION['usuario_id'],
			$_SESSION['usuario_id'],
			'0'		
		);
		$dts=$oKardex->ultimoInsert();
		$dt = mysqli_fetch_array($dts);
		$kar_id_salida=$dt['id'];
		mysqli_free_result($dts);
		
		
		
		
		
		$dts1 = $oDistribucion->mostrarporAlmacenes($_POST['almori_id'],$almdes_id,'','');		
		while($dt = mysqli_fetch_array($dts1)){
			
			$cat_id=$dt['tb_catalogo_id'];
			$lab_id=$dt['tb_laboratorio_id'];
			$can=$dt['tb_distribucioncarrito_can'];
			
			$oTraspaso->insertar_detalle(
				$cat_id,
				$lab_id,
				$can,
				$tra_id
			);
			
			
			$dts=$oStock->stock_por_presentacion($cat_id,$lab_id,$_POST['almori_id']);
			$dt = mysqli_fetch_array($dts);
				$sto_id		=$dt['tb_stock_id'];
				$sto_num	=$dt['tb_stock_num'];
			mysqli_free_result($dts);
			$stock_nuevo=$sto_num-$can;
			$oStock->modificar($sto_id,$stock_nuevo);
			
				$kar_tip=2;
			$oKardex->insertar_detalle(
				$cat_id,
				$lab_id,
				$kar_tip,
				$can,
				moneda_mysql($cat_precos/1.18),
				moneda_mysql($cat_precos/1.18),
				$kar_id_salida,
				$_POST['almori_id']
			);	
			
			
			
			//echo $dt['tb_distribucioncarrito_can'].'- cat -'.$dt['tb_catalogo_id'].' - '.$dt['tb_almacenorigen_id'].' - '.$dt['tb_almacendestino_id'].'</br>';
		
		}
		 
		 
		 //echo '---------------------------------------------'.'</br>';
		 
		 
	}
	
		$data["msj"]="Distribucion generada correctamente.";
		$data["est"]=1;
		
		$oDistribucion->eliminarCarrito();
	
	}else{
		$data["msj"]="Hay items que han superado el stock.";
		$data["est"]=0;
		$data["item"]=$msj;
	}
	
	echo json_encode($data); 
}






?>

